package com.steerinfo.baseinfo.appphonehelp.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.appphonehelp.model.AppPhoneHelp;
import com.steerinfo.baseinfo.appphonehelp.service.IAppPhoneHelpService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.jdbc.proxy.annotation.Post;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.apache.shiro.crypto.hash.Hash;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * AppPhoneHelp RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-18 05:31
 * 类描述
 * 修订历史：
 * 日期：2022-03-18
 * 作者：generator
 * 参考：
 * 描述：AppPhoneHelp RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/appphonehelps")
public class AppPhoneHelpController extends BaseRESTfulController {

    @Autowired
    IAppPhoneHelpService appPhoneHelpService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("appphonehelp:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<AppPhoneHelp> list = appPhoneHelpService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("appphonehelp:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<AppPhoneHelp> list = appPhoneHelpService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据AppPhoneHelp对象创建")
    @ApiImplicitParam(name = "appPhoneHelp", value = "详细实体appPhoneHelp", required = true, dataType = "AppPhoneHelp")
    //@RequiresPermissions("appphonehelp:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute AppPhoneHelp model){
        AppPhoneHelp appPhoneHelp = appPhoneHelpService.add(model);
        return success(appPhoneHelp);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("appphonehelp:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        AppPhoneHelp appPhoneHelp = appPhoneHelpService.getById(id);
        return success(appPhoneHelp);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的appPhoneHelp信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "appPhoneHelp", value = "详细实体appPhoneHelp", required = true, dataType = "AppPhoneHelp")
    })
    //@RequiresPermissions("appphonehelp:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody AppPhoneHelp model){
        model.setId(id);
        AppPhoneHelp appPhoneHelp = appPhoneHelpService.modify(model);
        return success(appPhoneHelp);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("appphonehelp:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  appPhoneHelpService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "App端远程求助按钮", notes = "App端远程求助按钮")
    @PostMapping(value = "/phoneHelp")
    public RESTfulResult phoneHelp(@RequestBody HashMap<String, Object> param) {
        RESTfulResult rm = failed();
        String carNo = param.get("carNo") == null ? "":param.get("carNo").toString();
        String phoneNo = param.get("phoneNo") == null ? "" : param.get("phoneNo").toString();
        String driverName = param.get("driverName") == null ? "" : param.get("driverName").toString();
        try{
            if(com.steerinfo.util.StringUtils.isEmpty(carNo)){
                rm.setMessage("车号不能为空！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(phoneNo)){
                rm.setMessage("电话号码不能为空！！");
                return rm;
            }
//            else if(com.steerinfo.util.StringUtils.isEmpty(driverName)){
//                rm.setMessage("司机姓名不能为空！！");
//                return rm;
//            }
            else{
                rm = appPhoneHelpService.phoneHelp(carNo, phoneNo, driverName);
            }
        }catch(Exception e){
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！！");
        }
        return rm;
    }

    @ApiOperation(value = "App端远程求助确认按钮", notes = "App端远程求助确认按钮")
    @PostMapping(value = "/phoneHelpConfirm")
    public RESTfulResult phoneHelpConfirm(@RequestBody HashMap params) {
        RESTfulResult rm = failed();
        String id = params.get("helpId") == null ? "": params.get("helpId").toString();
        String createNo = params.get("createNo") == null ? "" : params.get("createNo").toString();
        String createName = params.get("createName") == null ? "" : params.get("createName").toString();
        String result = params.get("result") == null ? "" : params.get("result").toString();
        try{
            if(com.steerinfo.util.StringUtils.isEmpty(id)){
                rm.setMessage("远程求助ID不能为空！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(createNo)){
                rm.setMessage("处理人编号不能为空！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(createName)){
                rm.setMessage("处理人名称不能为空！！");
                return rm;
            }else{
                rm = appPhoneHelpService.phoneHelpComfirm(id, createNo, createName, result);
            }
        }catch(Exception e){
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！！");
        }
        return rm;
    }

}
